     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                                                                          
     *_> DLTMOD MODULE(@5/@4)                                                                                          
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                                                           
     *_>   DBGVIEW(@9) OPTIMIZE(@8)                                                                                    
     * ---------------------------------------------------------------                                                 
     * Module.: TG0002_M03           Project.....:                                                                     
     * Author.: A. Campin            Date written: 04/03/2005                                                          
     * Purpose: Maintain Detail Trigger Control Records.                                                               
     * ---------------------------------------------------------------                                                 
     * Called by: TG0002_M02                                                                                           
     * ---------------------------------------------------------------                                                 
     * Revision history:                                                                                               
     *  Project # Pgmr        Date   Desc                                                                              
     *                                                                                                                 
     * End Revision History                                                                                            
     * ---------------------------------------------------------------                                                 
     *                  Standards                                                                                      
     *                  Function Keys.                                                                                 
     *                                                                                                                 
     *  F3  - SAA Exit.                                                                                                
     *  F5  - Reload Screen.                                                                                           
     *  F6  - Add Record.                                                                                              
     *  F12 - Previous Screen.                                                                                         
     * ---------------------------------------------------------------                                                 
     *                       Indicators                                                                                
     *                                                                                                                 
     * @@@ Indicators 1 - 25 for data base I/O.                                                                        
     *                                                                                                                 
     * @@@ Indicators 26 - 29 for subfile control.                                                                     
     *                                                                                                                 
     *      26 - Display subfile control.                                                                              
     *      27 - Display subfile.                                                                                      
     *      28 - Clear subfile.                                                                                        
     *      29 - SFLEND enabled.                                                                                       
     *                                                                                                                 
     * @@@ Indicators 30 - 49 display file I/O control.                                                                
     *                                                                                                                 
     * @@@ Indicators 50 - 79 field error indicators.                                                                  
     *                                                                                                                 
     * @@@ Indicators 80 - 94 Condition control.                                                                       
     *                                                                                                                 
     * @@@ Indicators 95 - 99 Scratch indicators.                                                                      
     *                                                                                                                 
     *      95 - Subfile message handler.                                                                              
     *      99 - Scratch indicator.                                                                                    
     * ---------------------------------------------------------------                                                 
      /EJECT                                                                                                            
     h NoMain                                                                                                           
                                                                                                                        
     fTG0002_D01cf   e             WorkStn InfDs(FI01)                                                                  
     f                                     Sfile(RD01_03S:                                                              
     f                                           SubfileRecordNumber)                                                   
     f                                     UsrOpn                                                                       
     f                                     Include(RD01_03S:                                                            
     f                                             RD01_03C:                                                            
     f                                             RD01_03O:                                                            
     f                                             SF_BLANK:                                                            
     f                                             SFMSG_CTL)                                                           
     fTGCTRLD_00if   e           k Disk    UsrOpn                                                                       
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_CON                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,CB_STDTYPE                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,XVMSGF_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,TG0002_LP                                                                                       
                                                                                                                        
      /Define cb_DisplaySubfileMessages_PR                                                                              
      /copy *libl/qsrcf,CB_DSPSFM                                                                                       
      /Undefine cb_DisplaySubfileMessages_PR                                                                            
                                                                                                                        
     d INT_LoadSubfile...                                                                                               
     d                 pr                                                                                               
                                                                                                                        
     d INT_ClearSubfile...                                                                                              
     d                 pr                                                                                               
                                                                                                                        
     d INT_PositionInputFile...                                                                                         
     d                 pr                                                                                               
                                                                                                                        
     d INT_LoadOnePage...                                                                                               
     d                 pr                                                                                               
                                                                                                                        
     d INT_LoadPreviousPage...                                                                                          
     d                 pr                                                                                               
                                                                                                                        
     d INT_WriteSubfileRecord...                                                                                        
     d                 pr                                                                                               
                                                                                                                        
     d INT_GetSelectedRecords...                                                                                        
     d                 pr                  Like(StdChr)                                                                 
                                                                                                                        
      /copy *libl/qsrcf,CB_MAP_IND                                                                                      
     d DisplaySubfileControl...                                                                                         
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN26)                                                         
     d DisplaySubfile...                                                                                                
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN27)                                                         
     d ClearSubfile...                                                                                                  
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN28)                                                         
     d DisplaySubfileEnd...                                                                                             
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN29)                                                         
     d SubfileNextChanged...                                                                                            
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN86)                                                         
     d PositionToChanged...                                                                                             
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN89)                                                         
     d DisplaySubfileEndOnSubfileMessageQueue...                                                                        
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIn95)                                                         
                                                                                                                        
     d ProgramName...                                                                                                   
     d                 s                   Like(StdNam)                                                                 
     d                                     Import                                                                       
                                                                                                                        
      * File Information Display File 01.                                                                               
     d FI01...                                                                                                          
     d                 ds                  Qualified                                                                    
     d   KeyPressed...                                                                                                  
     d                       369    369                                                                                 
                                                                                                                        
     d SystemDataStructure...                                                                                           
     d                sds           333    Qualified                                                                    
     d   ModuleName...                                                                                                  
     d                         1     10                                                                                 
     d   UserName...                                                                                                    
     d                       254    263                                                                                 
                                                                                                                        
      /copy *libl/qsrcf,CB_KEYP                                                                                         
                                                                                                                        
     d cRecordsPerPage...                                                                                               
     d                 c                   Const(12)                                                                    
     d cEditRequest...                                                                                                  
     d                 c                   Const('2')                                                                   
     d cDeleteRequest...                                                                                                
     d                 c                   Const('4')                                                                   
     d cDisplayRequest...                                                                                               
     d                 c                   Const('5')                                                                   
     d cAddRecordMode...                                                                                                
     d                 c                   Const('A')                                                                   
     d cEditRecordMode...                                                                                               
     d                 c                   Const('E')                                                                   
     d cDisplayRecordMode...                                                                                            
     d                 c                   Const('D')                                                                   
     d cMainProcedureName...                                                                                            
     d                 c                   Const('PROCESSSCREEN03')                                                     
                                                                                                                        
     d SubfileRecordNumber...                                                                                           
     d                 s                   Like(StdScnRRN)                                                              
     d RecordsLoadedInSubfile...                                                                                        
     d                 s                   like(StdScnRRN)                                                              
     d RecordsLoadedOnPage...                                                                                           
     d                 s                   like(StdScnRRN)                                                              
                                                                                                                        
     d ScreenOpen...                                                                                                    
     d                 s                   Like(StdLgl)                                                                 
     d                                     Inz(cFalse)                                                                  
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * ProcessScreen03                                                                                                 
     *   Do processing for Screen Three - Standard Single Page Load Subfile Panel.                                     
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - Key Pressed                                                                                       
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p ProcessScreen03...                                                                                               
     p                 b                   Export                                                                       
     d                 pi                  Like(StdChr)                                                                 
                                                                                                                        
     d KeyPressed...                                                                                                    
     d                 s                   Like(StdLgl)                                                                 
      /Free                                                                                                             
                                                                                                                        
         If Not ScreenOpen;                                                                                             
           ScreenOpen = cTrue;                                                                                          
           Open TG0002_D01;                                                                                             
           Open TGCTRLD_00;                                                                                             
         EndIf;                                                                                                         
                                                                                                                        
         // Default is to display first file name.                                                                      
         O_CURPOSTO = *Blanks;                                                                                          
         B_NEWPOSTO = *Blanks;                                                                                          
                                                                                                                        
         MSGF_ClearProgramMessageQueue(cMainProcedureName            :                                                  
                                       SystemDataStructure.ModuleName:                                                  
                                       ProgramName                   );                                                 
         INT_LoadSubfile();                                                                                             
         DoU 0 = 1;                                                                                                     
                                                                                                                        
           DisplaySubfileMessages();                                                                                    
           If RecordsLoadedInSubFile > 0;                                                                               
             DisplaySubFile = cTrue;                                                                                    
           Else;                                                                                                        
             DisplaySubfile = cFalse;                                                                                   
             Write SF_BLANK;                                                                                            
           EndIf;                                                                                                       
           DisplaySubFileControl = cTrue;                                                                               
                                                                                                                        
           Write RD01_03O;                                                                                              
           ExFmt RD01_03C;                                                                                              
                                                                                                                        
           MSGF_ClearProgramMessageQueue(cMainProcedureName            :                                                
                                         SystemDataStructure.ModuleName:                                                
                                         ProgramName                   );                                               
           MSGF_ClearErrorIndicators(*IN                  :                                                             
                                     cStartErrorIndicators:                                                             
                                     cEndErrorIndicators  );                                                            
                                                                                                                        
           DisplaySubfile        = cFalse;                                                                              
           DisplaySubfileControl = cFalse;                                                                              
                                                                                                                        
           Select;                                                                                                      
             When FI01.KeyPressed = F3 or                                                                               
                  FI01.KeyPressed = F12;                                                                                
               Return FI01.KeyPressed;                                                                                  
             // F5 = Reload screen.                                                                                     
             When FI01.KeyPressed = F5;                                                                                 
               INT_LoadSubfile();                                                                                       
               Iter;                                                                                                    
             // F6 = Add Record Request.                                                                                
             When FI01.KeyPressed = F6;                                                                                 
               If ProcessScreen04(' '           :                                                                       
                                  ' '           :                                                                       
                                  cAddRecordMode) = F3;                                                                 
                  Return F3;                                                                                            
               EndIf;                                                                                                   
               INT_LoadSubfile();                                                                                       
               Iter;                                                                                                    
             //Rolldown-Display previous page.                                                                          
             When FI01.KeyPressed = RollDown;                                                                           
               INT_LoadPreviousPage();                                                                                  
               Iter;                                                                                                    
             //Rollup-Display next page.                                                                                
             When FI01.KeyPressed = RollUp;                                                                             
               INT_LoadOnePage();                                                                                       
               Iter;                                                                                                    
             Other;                                                                                                     
               If PositionToChanged;                                                                                    
                 O_CURPOSTO = B_NEWPOSTO;                                                                               
                 B_NEWPOSTO = *Blanks;                                                                                  
                 INT_LoadSubfile();                                                                                     
                 Iter;                                                                                                  
               EndIf;                                                                                                   
                                                                                                                        
               // If nothing loaded, redisplay subfile.                                                                 
               If RecordsLoadedInSubfile <= 0;                                                                          
                 Iter;                                                                                                  
               EndIf;                                                                                                   
                                                                                                                        
               //Check for options selected.                                                                            
               KeyPressed = INT_GetSelectedRecords();                                                                   
               If KeyPressed = F3;                                                                                      
                 Return F3;                                                                                             
               EndIf;                                                                                                   
                                                                                                                        
               If KeyPressed = F12;                                                                                     
                 Iter;                                                                                                  
               EndIf;                                                                                                   
                                                                                                                        
               //Call function to display screen. If nothing, will just return.                                         
               //F12 means abort request. Redisplay screen.                                                             
               If ProcessScreen05() = F12;                                                                              
                 Iter;                                                                                                  
               EndIf;                                                                                                   
                                                                                                                        
               // Else, mormal end. Reload subfile.                                                                     
               INT_LoadSubfile();                                                                                       
               Iter;                                                                                                    
           EndSl;                                                                                                       
         EndDo;                                                                                                         
                                                                                                                        
         Return ' ';                                                                                                    
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * CloseScreen03                                                                                                   
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - None                                                                                              
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p CloseScreen03...                                                                                                 
     p                 b                   Export                                                                       
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         Close TG0002_D01;                                                                                              
         Close TGCTRLD_00;                                                                                              
         ScreenOpen = cFalse;                                                                                           
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_LoadSubfile                                                                                                 
     *   Load subfile.                                                                                                 
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_LoadSubfile...                                                                                               
     p                 b                                                                                                
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         INT_ClearSubFile();                                                                                            
         INT_PositionInputFile();                                                                                       
         INT_LoadOnePage();                                                                                             
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_ClearSubfile                                                                                                
     *   Clear Subfile.                                                                                                
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_ClearSubfile...                                                                                              
     p                 b                                                                                                
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         RecordsLoadedInSubfile = 0;                                                                                    
                                                                                                                        
         ClearSubfile = cTrue;                                                                                          
         Write RD01_03C;                                                                                                
         ClearSubfile = cFalse;                                                                                         
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_PositionInputFile                                                                                           
     *   Set position of input file for subfile to current position.                                                   
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_PositionInputFile...                                                                                         
     p                 b                                                                                                
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         Setll O_CURPOSTO TGCTRLD_00;                                                                                   
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_LoadOnePage                                                                                                 
     *   Load one page of subfile records.                                                                             
     *     Input     - None                                                                                            
     *     Out       - None                                                                                            
     *     Returns   - None.                                                                                           
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_LoadOnePage...                                                                                               
     p                 b                                                                                                
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
          RecordsLoadedOnPage = 0;                                                                                      
                                                                                                                        
          DoU RecordsLoadedOnPage >= cRecordsPerPage;                                                                   
            Read TGCTRLD_00;                                                                                            
            If %Eof(TGCTRLD_00);                                                                                        
              Leave;                                                                                                    
            EndIf;                                                                                                      
                                                                                                                        
            INT_WriteSubfileRecord();                                                                                   
          EndDo;                                                                                                        
                                                                                                                        
          // If count of records loaded on page is zero and records in                                                  
          //  subfile is zero, then no records found to load.                                                           
          If RecordsLoadedOnPage = 0;                                                                                   
            If RecordsLoadedInSubfile = 0;                                                                              
              MSGF_SendProgramMessage('UXV0026'                     :                                                   
                                      cXVMessageFileName            :                                                   
                                      ' '                           :                                                   
                                      cMainProcedureName            :                                                   
                                      SystemDataStructure.ModuleName:                                                   
                                      ProgramName                   );                                                  
            Else;                                                                                                       
            // No records found to load.                                                                                
              MSGF_SendProgramMessage('UXV0027'                     :                                                   
                                      cXVMessageFileName            :                                                   
                                      ' '                           :                                                   
                                      cMainProcedureName            :                                                   
                                      SystemDataStructure.ModuleName:                                                   
                                      ProgramName                   );                                                  
            EndIf;                                                                                                      
          EndIf;                                                                                                        
                                                                                                                        
          // Set position of sub-file to be last record loaded.                                                         
          H_SFPOS = SubfileRecordNumber;                                                                                
                                                                                                                        
          // If not EOF, check if more records.                                                                         
          If Not %Eof(TGCTRLD_00);                                                                                      
            DisplaySubfileEnd = cTrue;                                                                                  
          Else;                                                                                                         
            Read TGCTRLD_00;                                                                                            
            If %Eof(TGCTRLD_00);                                                                                        
              DisplaySubfileEnd = cTrue;                                                                                
            Else;                                                                                                       
              ReadP TGCTRLD_00;                                                                                         
              DisplaySubfileEnd = cFalse;                                                                               
            EndIf;                                                                                                      
          EndIf;                                                                                                        
                                                                                                                        
          Return;                                                                                                       
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_LoadPreviousPage                                                                                            
     *   Load previous page of records.                                                                                
     *     Input     - None                                                                                            
     *     Out       - None                                                                                            
     *     Returns   - None.                                                                                           
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_LoadPreviousPage...                                                                                          
     p                 b                                                                                                
     d                 pi                                                                                               
                                                                                                                        
     d RecordsBack...                                                                                                   
     d                 s                   Like(StdIntSml)                                                              
      /Free                                                                                                             
                                                                                                                        
         // If when we load the subfile, we hit EOF on the first page we                                                
         //  loaded, we need to reposition to the last record for rollback.                                             
         //  We do not want to do this if we hit EOF when rolling forward.                                              
         If %Eof(TGCTRLD_00) and                                                                                        
            RecordsLoadedInSubfile <= cRecordsPerPage;                                                                  
           Setll *HiVal TGCTRLD_00;                                                                                     
           RecordsLoadedOnPage += 1;                                                                                    
         EndIf;                                                                                                         
                                                                                                                        
         // Get subfile size number of records previous, if possible.                                                   
         RecordsBack = cRecordsPerPage + RecordsLoadedOnPage;                                                           
         DoU RecordsBack <= 0;                                                                                          
           ReadP TGCTRLD_00;                                                                                            
           If %Eof(TGCTRLD_00);                                                                                         
             Leave;                                                                                                     
           EndIf;                                                                                                       
           RecordsBack -= 1;                                                                                            
         EndDo;                                                                                                         
                                                                                                                        
         // If EOF, hit beginning of file.                                                                              
         If %Eof(TGCTRLD_00);                                                                                           
           O_CURPOSTO = *Blanks;                                                                                        
           INT_PositionInputFile();                                                                                     
           MSGF_SendProgramMessage('UXV0028':                                                                           
                                   cXVMessageFileName            :                                                      
                                   ' '                           :                                                      
                                   cMainProcedureName            :                                                      
                                   SystemDataStructure.ModuleName:                                                      
                                   ProgramName                   );                                                     
         EndIf;                                                                                                         
                                                                                                                        
         INT_ClearSubfile();                                                                                            
         INT_LoadOnePage();                                                                                             
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_WriteSubfileRecord                                                                                          
     *   Write one record to the subfile.                                                                              
     *     Input     - None                                                                                            
     *     Out       - None                                                                                            
     *     Returns   - None.                                                                                           
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_WriteSubfileRecord...                                                                                        
     p                 b                                                                                                
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         RecordsLoadedInSubfile += 1;                                                                                   
         SubfileRecordNumber     = RecordsLoadedInSubfile;                                                              
         RecordsLoadedOnPage    += 1;                                                                                   
                                                                                                                        
         B_OPTION = *Blanks;                                                                                            
                                                                                                                        
         O_FILENAME = TDFILENAME;                                                                                       
         O_LIBNAME  = TDLIBNAME;                                                                                        
         O_ACTIVE   = TDACTIVE;                                                                                         
         O_SRVPGM   = TDSRVPGM;                                                                                         
         O_SRVLIB   = TDSRVLIB;                                                                                         
         O_SRVPROC  = %Subst(TDSRVPROC:1:%Size(O_SRVPROC));                                                             
                                                                                                                        
         // SFLNXTCHG always off.                                                                                       
         SubfileNextChanged = cFalse;                                                                                   
         H_SFLNXTCH = SubfileNextChanged;                                                                               
                                                                                                                        
         Write RD01_03S;                                                                                                
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_GetSelectedRecords                                                                                          
     *   Get all selected records from subfile.                                                                        
     *     Input     - None                                                                                            
     *     Out       - None                                                                                            
     *     Returns   - Key pressed.                                                                                    
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_GetSelectedRecords...                                                                                        
     p                 b                                                                                                
     d                 pi                  Like(StdChr)                                                                 
                                                                                                                        
     d KeyPressed...                                                                                                    
     d                 s                   Like(StdChr)                                                                 
      /Free                                                                                                             
                                                                                                                        
         // Clear display delete confirmation.                                                                          
         ClearSubfile05();                                                                                              
                                                                                                                        
         KeyPressed = *Blank;                                                                                           
         DoU KeyPressed = F12 or                                                                                        
             KeyPressed = F3;                                                                                           
           ReadC RD01_03S;                                                                                              
           If %Eof(TG0002_D01);                                                                                         
             Leave;                                                                                                     
           EndIf;                                                                                                       
                                                                                                                        
           // Restore indicators;                                                                                       
           SubfileNextChanged = H_SFLNXTCH;                                                                             
                                                                                                                        
           Select;                                                                                                      
             When B_OPTION = cEditRequest;                                                                              
               KeyPressed = ProcessScreen04(O_FILENAME     :                                                            
                                            O_LIBNAME      :                                                            
                                            cEditRecordMode);                                                           
             When B_OPTION = cDeleteRequest;                                                                            
               WriteSubfile05(O_FILENAME:                                                                               
                              O_LIBNAME );                                                                              
               SubfileNextChanged = cTrue;                                                                              
             When B_OPTION = cDisplayRequest;                                                                           
               KeyPressed = ProcessScreen04(O_FILENAME        :                                                         
                                            O_LIBNAME         :                                                         
                                            cDisplayRecordMode);                                                        
           EndSl;                                                                                                       
                                                                                                                        
           // If previous screen request, enable SFLNXTCHG for this record.                                             
           If KeyPressed = F12;                                                                                         
             SubfileNextChanged = cTrue;                                                                                
           Else;                                                                                                        
             If B_OPTION <> cDeleteRequest;                                                                             
               B_OPTION = *Blanks;                                                                                      
             EndIf;                                                                                                     
           EndIf;                                                                                                       
                                                                                                                        
           H_SFLNXTCH = SubfileNextChanged;                                                                             
                                                                                                                        
           Update RD01_03S;                                                                                             
                                                                                                                        
           SubfileNextChanged = cFalse;                                                                                 
                                                                                                                        
           MSGF_ClearErrorIndicators(*IN                  :                                                             
                                     cStartErrorIndicators:                                                             
                                     cEndErrorIndicators  );                                                            
         EndDo;                                                                                                         
                                                                                                                        
         Return KeyPressed;                                                                                             
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
      /Define cb_DisplaySubfileMessages_PI                                                                              
      /copy *libl/qsrcf,CB_DSPSFM                                                                                       
      /Undefine cb_DisplaySubfileMessages_PI                                                                            
