     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                                                                          
     *_> DLTMOD MODULE(@5/@4)                                                                                          
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                                                           
     *_>   DBGVIEW(@9) OPTIMIZE(@8)                                                                                    
     * ---------------------------------------------------------------                                                 
     * Module.: TG0002_M05           Project.....:                                                                     
     * Author.: A. Campin            Date written: 04/07/2005                                                          
     * Purpose: Maintain Detail Trigger Control Records. Confirm delete                                                
     *            of Detail Records.                                                                                   
     * ---------------------------------------------------------------                                                 
     * Called by: TG0002_M03                                                                                           
     * ---------------------------------------------------------------                                                 
     * Revision history:                                                                                               
     *  Project # Pgmr        Date   Desc                                                                              
     *                                                                                                                 
     * End Revision History                                                                                            
     * ---------------------------------------------------------------                                                 
     *                  Standards                                                                                      
     *                  Function Keys.                                                                                 
     *                                                                                                                 
     *  F3  - SAA Exit.                                                                                                
     *  F12 - Previous Screen.                                                                                         
     * ---------------------------------------------------------------                                                 
     *                       Indicators                                                                                
     *                                                                                                                 
     * @@@ Indicators 1 - 25 for data base I/O.                                                                        
     *                                                                                                                 
     * @@@ Indicators 26 - 29 for subfile control.                                                                     
     *                                                                                                                 
     *      26 - Display subfile control.                                                                              
     *      27 - Display subfile.                                                                                      
     *      28 - Clear subfile.                                                                                        
     *      29 - SFLEND enabled.                                                                                       
     *                                                                                                                 
     * @@@ Indicators 30 - 49 display file I/O control.                                                                
     *                                                                                                                 
     * @@@ Indicators 50 - 79 field error indicators.                                                                  
     *                                                                                                                 
     * @@@ Indicators 80 - 94 Condition control.                                                                       
     *                                                                                                                 
     * @@@ Indicators 95 - 99 Scratch indicators.                                                                      
     *                                                                                                                 
     *      98 - Subfile message handler.                                                                              
     *      99 - Scratch indicator.                                                                                    
     * ---------------------------------------------------------------                                                 
      /EJECT                                                                                                            
     h nomain                                                                                                           
                                                                                                                        
     fTG0002_D01cf   e             Workstn InfDs(FI01)                                                                  
     f                                     Sfile(RD01_05S           :                                                   
     f                                           SubfileRecordNumber)                                                   
     f                                     UsrOpn                                                                       
     f                                     Include(RD01_05S:                                                            
     f                                             RD01_05C:                                                            
     f                                             RD01_05O:                                                            
     f                                             SF_BLANK:                                                            
     f                                             SFMSG_CTL)                                                           
ts006fTGCTRLD_00uf   e           k Disk    UsrOpn                                                                       
                                                                                                                        
      /copy *libl/qsrcf,cb_Std_Con                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,cb_StdType                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,XVMSGF_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,TG0002_LP                                                                                       
                                                                                                                        
      /Define cb_DisplaySubfileMessages_PR                                                                              
      /copy *libl/qsrcf,CB_DSPSFM                                                                                       
      /Undefine cb_DisplaySubfileMessages_PR                                                                            
                                                                                                                        
     d INT_DeleteRecords...                                                                                             
     d                 pr                                                                                               
                                                                                                                        
      /copy *libl/qsrcf,CB_MAP_IND                                                                                      
     d DisplaySubfileControl...                                                                                         
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN26)                                                         
     d DisplaySubfile...                                                                                                
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN27)                                                         
     d ClearSubfile...                                                                                                  
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN28)                                                         
     d DisplaySubfileEnd...                                                                                             
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN29)                                                         
     d DisplaySubfileEndOnSubfileMessageQueue...                                                                        
     d                                     Like(StdLgl)                                                                 
     d                                     Overlay(GenericIN95)                                                         
                                                                                                                        
      /copy *libl/qsrcf,CB_KEYP                                                                                         
                                                                                                                        
     d cMainProcedureName...                                                                                            
     d                 c                   Const('PROCESSSCREEN05')                                                     
     d ProgramName...                                                                                                   
     d                 s                   Like(StdNam)                                                                 
     d                                     Import                                                                       
     *--------------------------------------------------------------                                                   
     * File information data structure for display file one.                                                           
     d FI01...                                                                                                          
     d                 ds                  Qualified                                                                    
     d   KeyPressed...                                                                                                  
     d                       369    369                                                                                 
                                                                                                                        
     d SystemDataStructure...                                                                                           
     d                sds           333    Qualified                                                                    
     d                                                                                                                  
     d   ModuleName...                                                                                                  
     d                         1     10                                                                                 
     d   UserName...                                                                                                    
     d                       254    263                                                                                 
                                                                                                                        
     d ScreenOpen...                                                                                                    
     d                 s                   Like(StdLgl)                                                                 
     d                                     Inz(cFalse)                                                                  
     d SubfileRecordNumber...                                                                                           
     d                 s                   Like(StdScnRRN)                                                              
     d RecordsInSubfile...                                                                                              
     d                 s                   Like(StdIntSml)                                                              
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * ClearSubfile05                                                                                                  
     *  Clear Subfile in Screen 05.                                                                                    
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - None                                                                                              
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p ClearSubfile05...                                                                                                
     p                 b                   Export                                                                       
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         If Not ScreenOpen;                                                                                             
           ScreenOpen = cTrue;                                                                                          
           Open TG0002_D01;                                                                                             
           Open TGCTRLD_00;                                                                                             
         EndIf;                                                                                                         
                                                                                                                        
         ClearSubfile     = cTrue;                                                                                      
         Write RD01_05C;                                                                                                
         ClearSubfile     = cFalse;                                                                                     
         RecordsInSubfile = 0;                                                                                          
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * WriteSubfile05                                                                                                  
     *   Write record to confirm delete subfile.                                                                       
     *   Input     - File Name to delete.                                                                              
     *   Out       - None.                                                                                             
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p WriteSubfile05...                                                                                                
     p                 b                   Export                                                                       
     d                 pi                                                                                               
     d   InFileName...                                                                                                  
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d   InLibraryName...                                                                                               
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
      /Free                                                                                                             
                                                                                                                        
         Chain(n) (InFileName:InLibraryName) TGCTRLD_00;                                                                
         If Not %Found(TGCTRLD_00);                                                                                     
           Return;                                                                                                      
         EndIf;                                                                                                         
                                                                                                                        
         RecordsInSubfile += 1;                                                                                         
         SubfileRecordNumber = RecordsInSubfile;                                                                        
                                                                                                                        
         O_FILENAME = TDFILENAME;                                                                                       
         O_LIBNAME  = TDLIBNAME;                                                                                        
         O_ACTIVE   = TDACTIVE;                                                                                         
         O_SRVPGM   = TDSRVPGM;                                                                                         
         O_SRVLIB   = TDSRVLIB;                                                                                         
         O_SRVPROC  = %Subst(TDSRVPROC:1:%Size(O_SRVPROC));                                                             
                                                                                                                        
         Write RD01_05S;                                                                                                
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * ProcessScreen05                                                                                                 
     *  Do processing for Screen05-Standard Delete Confirmation Panel.                                                 
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - Key Pressed to End.                                                                               
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p ProcessScreen05...                                                                                               
     p                 b                   Export                                                                       
     d                 pi                  like(StdChr)                                                                 
      /Free                                                                                                             
                                                                                                                        
         // If nothing to display, just return.                                                                         
         If RecordsInSubfile <= 0;                                                                                      
           Return ' ';                                                                                                  
         EndIf;                                                                                                         
                                                                                                                        
         MSGF_ClearProgramMessageQueue(cMainProcedureName            :                                                  
                                       SystemDataStructure.ModuleName:                                                  
                                       ProgramName                   );                                                 
         DoU 0 = 1;                                                                                                     
                                                                                                                        
           DisplaySubfileMessages();                                                                                    
                                                                                                                        
           If RecordsInSubfile > 0;                                                                                     
             DisplaySubfile = cTrue;                                                                                    
           Else;                                                                                                        
             DisplaySubfile = cFalse;                                                                                   
             Write SF_BLANK;                                                                                            
           EndIf;                                                                                                       
                                                                                                                        
           DisplaySubFileControl = cTrue;                                                                               
           DisplaySubfileEnd     = cTrue;                                                                               
                                                                                                                        
           Write RD01_05O;                                                                                              
           ExFmt RD01_05C;                                                                                              
                                                                                                                        
           MSGF_ClearProgramMessageQueue(cMainProcedureName            :                                                
                                         SystemDataStructure.ModuleName:                                                
                                         ProgramName                   );                                               
                                                                                                                        
           MSGF_ClearErrorIndicators(*IN                  :                                                             
                                     cStartErrorIndicators:                                                             
                                     cEndErrorIndicators  );                                                            
                                                                                                                        
           DisplaySubfile        = cFalse;                                                                              
           DisplaySubfileControl = cFalse;                                                                              
                                                                                                                        
           Select;                                                                                                      
             When FI01.KeyPressed = F3 or                                                                               
                  FI01.KeyPressed = F12;                                                                                
                Return FI01.KeyPressed;                                                                                 
             Other;                                                                                                     
               INT_DeleteRecords();                                                                                     
               Return Enter;                                                                                            
           EndSl;                                                                                                       
         EndDo;                                                                                                         
                                                                                                                        
         Return *Blank;                                                                                                 
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * CloseScreen05                                                                                                   
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - None                                                                                              
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p CloseScreen05...                                                                                                 
     p                 b                   Export                                                                       
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         Close TG0002_D01;                                                                                              
         Close TGCTRLD_00;                                                                                              
         ScreenOpen = cFalse;                                                                                           
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * INT_DeleteRecords                                                                                               
     *  Delete records from database.                                                                                  
     *   Input     - None                                                                                              
     *   Out       - None                                                                                              
     *   Returns   - None.                                                                                             
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p INT_DeleteRecords...                                                                                             
     p                 b                                                                                                
     d                 pi                                                                                               
      /Free                                                                                                             
                                                                                                                        
         For SubfileRecordNumber = 1 to RecordsInSubfile;                                                               
           Chain SubfileRecordNumber RD01_05S;                                                                          
           Delete (O_FILENAME:O_LIBNAME) RCTRLD_00;                                                                     
         EndFor;                                                                                                        
                                                                                                                        
         Return;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
      /Define cb_DisplaySubfileMessages_PI                                                                              
      /copy *libl/qsrcf,CB_DSPSFM                                                                                       
      /Undefine cb_DisplaySubfileMessages_PI                                                                            
