     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                                                                          
     *_> DLTMOD MODULE(@5/@4)                                                                                          
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                                                           
     *_>   DBGVIEW(@9) OPTIMIZE(@8)                                                                                    
     * ---------------------------------------------------------------                                                 
     * Module.....: TS0001_M01       Project.....:                                                                     
     * Author.....: A. Campin        Date written: 04/09/2005                                                          
     * Purpose....: Trigger Service Program Templete. This module                                                      
     *              implements a trigger handling service program                                                      
     *              and will be called by TG_MED dynamically. The                                                      
     *              name of the program is stored in table TGCTRLD.                                                    
     * ---------------------------------------------------------------                                                 
     * Called by..: TG_MED                                                                                             
     * ---------------------------------------------------------------                                                 
     * Revision history:                                                                                               
     *  Project # Pgmr        Date   Desc                                                                              
     *                                                                                                                 
     * End Revision History                                                                                            
     * ---------------------------------------------------------------                                                 
     h nomain                                                                                                           
                                                                                                                        
      /copy *libl/qsrcf,TG_MED_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,CB_STDTYPE                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_CON                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,XVERRH_PR                                                                                       
                                                                                                                        
     d TriggerServiceProcedure...                                                                                       
     d                 pr                                                                                               
     d    PR_InTriggerBuffer...                                                                                         
     d                            32767                                                                                 
     d    PR_InTriggerBufferLength...                                                                                   
     d                                     Like(StdInt)                                                                 
                                                                                                                        
     p TriggerServiceProcedure...                                                                                       
     p                 b                   Export                                                                       
     d                 pi                                                                                               
     d   InTriggerBuffer...                                                                                             
     d                            32767                                                                                 
     d   InTriggerBufferLength...                                                                                       
     d                                     Like(StdInt)                                                                 
                                                                                                                        
      /copy *libl/qsrcf,CB_DBTRG_S                                                                                      
                                                                                                                        
     ******************************************************                                                            
     * Important: Always set this value to the name of the                                                             
     *             file that this trigger service program                                                              
     *             is providing service for.                                                                           
     d cFileName...                                                                                                     
     d                 c                   Const('TESTTRIG')                                                            
                                                                                                                        
     d DbBefore...                                                                                                      
     d               e ds                  ExtName(cFileName)                                                           
     d                                     Prefix(XB:2)                                                                 
     d                                     Based(ptrDbBefore)                                                           
     d DbAfter...                                                                                                       
     d               e ds                  ExtName(cFileName)                                                           
     d                                     Prefix(XA:2)                                                                 
     d                                     Based(ptrDbAfter)                                                            
                                                                                                                        
     d MsgUTG0004...                                                                                                    
     d                 ds                  Qualified                                                                    
     d   TriggerProgramName...                                                                                          
     d                                     Like(StdNam)                                                                 
     d   TriggerProgramLibrary...                                                                                       
     d                                     Like(StdNam)                                                                 
     d   ShouldBeName...                                                                                                
     d                                     Like(StdNam)                                                                 
     d   IsName...                                                                                                      
     d                                     Like(StdNam)                                                                 
     d MsgUTG0005...                                                                                                    
     d                 ds                  Qualified                                                                    
     d   TriggerProgramName...                                                                                          
     d                                     Like(StdNam)                                                                 
     d   TriggerProgramLibrary...                                                                                       
     d                                     Like(StdNam)                                                                 
     d   FileName...                                                                                                    
     d                                     Like(StdNam)                                                                 
     d   ActualSizeOfRecord...                                                                                          
     d                                5p 0                                                                              
     d   ShouldBeSizeOfRecord...                                                                                        
     d                                5p 0                                                                              
      /Free                                                                                                             
                                                                                                                        
         // Map the incoming buffer to buffer fields.                                                                   
         ptrDbTriggerBuffer = %Addr(InTriggerBuffer);                                                                   
                                                                                                                        
         // If wrong service program called, throw an error.                                                            
         If DbTriggerBuffer.PhysicalFileName <> cFileName;                                                              
           MsgTG0004.ShouldBeName = cFileName;                                                                          
           MsgTG0004.IsName       = DbTriggerBuffer.PhysicalFileName;                                                   
           ERRH_Throw('UTG0004'         :                                                                               
                      cXVMessageFileName:                                                                               
                      MsgUTG0004        );                                                                              
         EndIf;                                                                                                         
                                                                                                                        
         // If record sizes do not match, throw an error.                                                               
         If %Size(DbBefore) <> DbTriggerBuffer.BeforeLength;                                                            
           MsgUTG0005.FileName = DbTriggerBuffer.PhysicalFileName;                                                      
           MsgUTG0005.ActualSizeOfRecord   = DbTriggerBuffer.BeforeLength;                                              
           MsgUTG0005.ShouldBeSizeOfRecord = %Size(DbBefore);                                                           
           ERRH_Throw('UTG0005'         :                                                                               
                      cXVMessageFileName:                                                                               
                      MsgUTG0005        );                                                                              
         EndIf;                                                                                                         
                                                                                                                        
         // Map the actual data to the before and after images.                                                         
         ptrDbBefore = %Addr(InTriggerBuffer) + DbTriggerBuffer.BeforeOffset;                                           
         ptrDbAfter  = %Addr(InTriggerBuffer) + DbTriggerBuffer.AfterOffset;                                            
                                                                                                                        
         // Insert your code here to process Database change.                                                           
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
