     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                                                                          
     *_> DLTMOD MODULE(@5/@4)                                                                                          
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                                                           
     *_>   DBGVIEW(@9) OPTIMIZE(@8)                                                                                    
     * ---------------------------------------------------------------                                                 
     * Module.: XVDYNL_M01           Project.....:                                                                     
     * Author.: A. Campin            Date written: 02/24/2005                                                          
     * Purpose: Implementation of functions to dynamically load                                                        
     *            service programs and get pointer to Procedures and                                                   
     *            exported variables.                                                                                  
     * ---------------------------------------------------------------                                                 
     * Called by:                                                                                                      
     * ---------------------------------------------------------------                                                 
     * Revision history:                                                                                               
     *  Project # Pgmr        Date   Desc                                                                              
     *                                                                                                                 
     * End Revision History                                                                                            
     * ---------------------------------------------------------------                                                 
      /EJECT                                                                                                            
     h nomain                                                                                                           
                                                                                                                        
      /copy *libl/qsrcf,cb_StdType                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,cb_Std_Con                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,XVDYNL_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,XVRSLV_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,XVERRH_PR                                                                                       
                                                                                                                        
     d GetAProcedurePointer...                                                                                          
     d                 pr                  Like(StdPrcPtr)                                                              
     d   PR_InActivationMark...                                                                                         
     d                                     Like(StdInt)                                                                 
     d                                     Value                                                                        
     d   PR_InProcedureName...                                                                                          
     d                             4096    Varying                                                                      
     d                                     Value                                                                        
                                                                                                                        
     d GetAVariablePointer...                                                                                           
     d                 pr                  Like(StdPtr)                                                                 
     d   PR_InActivationMark...                                                                                         
     d                                     Like(StdInt)                                                                 
     d                                     Value                                                                        
     d   PR_InVariableName...                                                                                           
     d                             4096    Varying                                                                      
     d                                     Value                                                                        
                                                                                                                        
     d LowerToUpperCase...                                                                                              
     d                 pr         32767    Varying                                                                      
     d   PR_InString...                                                                                                 
     d                            32767    Varying                                                                      
     d                                     Value                                                                        
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     * DYNL_ActivateServiceProgram                                                                                     
     *   Function is responsilble for dynamically activating a service                                                 
     *                  program and returning a mark to be used to get                                                 
     *                  a pointer to a procedure or exported variable.                                                 
     *  In     Parms - Service Program Name.                                                                           
     *                 Service Program Library.                                                                        
     *  In/Out Parms - None.                                                                                           
     *  Out    Parms - None.                                                                                           
     *  Return       - Activation Mark.                                                                                
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     p DYNL_ActivateServiceProgram...                                                                                   
     p                 b                   Export                                                                       
     d                 pi                  Like(StdInt)                                                                 
     d   InServiceProgramName...                                                                                        
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d   InServiceProgramLibrary...                                                                                     
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_EM                                                                                       
                                                                                                                        
     d QleActBndPgm    pr                  ExtProc('QleActBndPgm')                                                      
     d                                     Like(StdInt)                                                                 
     d   PR_SystemPointer...                                                                                            
     d                                     Like(StdPrcPtr)                                                              
     d                                     Const                                                                        
     d   PR_ActivationMark...                                                                                           
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d                                     Options(*Omit)                                                               
     d  PR_ActInf                    64A   Const                                                                        
     d                                     Options(*Omit)                                                               
     d  PR_ActInfLen                       Like(StdInt)                                                                 
     d                                     Const                                                                        
     d                                     Options(*omit)                                                               
     d  PR_APIErr                          Likeds(StdErrorModel)                                                        
     d                                     Options(*NoPass)                                                             
                                                                                                                        
     d cServiceProgramType...                                                                                           
     d                 c                   Const('*SRVPGM')                                                             
     d SystemPointer...                                                                                                 
     d                 s                   Like(StdPrcPtr)                                                              
     d ActivationMark...                                                                                                
     d                 s                   Like(StdInt)                                                                 
     d ApiError...                                                                                                      
     d                 ds                  LikeDs(StdErrorModel)                                                        
     d MessageId...                                                                                                     
     d                 s                   Like(StdMsgId)                                                               
     d qMessageFileName...                                                                                              
     d                 s                   Like(StdQNam)                                                                
     d MessageData...                                                                                                   
     d                 s          32767    Varying                                                                      
      /Free                                                                                                             
                                                                                                                        
         Monitor;                                                                                                       
           SystemPointer = RSLV_ResolveToSystemPointer(InServiceProgramName   :                                         
                                                       InServiceProgramLibrary:                                         
                                                       cServiceProgramType    );                                        
         On-Error;                                                                                                      
           ERRH_GetLastMessage(MessageId       :                                                                        
                               qMessageFileName:                                                                        
                               MessageData     );                                                                       
           ERRH_Throw(MessageId       :                                                                                 
                      qMessageFileName:                                                                                 
                      MessageData     );                                                                                
         EndMon;                                                                                                        
                                                                                                                        
         ActivationMark = QleActBndPgm(SystemPointer:                                                                   
                                       *OMIT        :                                                                   
                                       *OMIT        :                                                                   
                                       *OMIT        :                                                                   
                                       ApiError     );                                                                  
         If ApiError.BytesAvailable > 0;                                                                                
            ERRH_Throw(ApiError.MessageId  :                                                                            
                       cCPFMessageFileName :                                                                            
                       ApiError.MessageData);                                                                           
         EndIf;                                                                                                         
                                                                                                                        
         Return ActivationMark;                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     * DYNL_GetPointerToProcedure                                                                                      
     *   Function is responsible for getting a pointer to a procedure using                                            
     *     a previously retrieved activition mark to the service program                                               
     *     containing the procedure.                                                                                   
     *  In     Parms - Procedure Name.                                                                                 
     *                 Activation Mark.                                                                                
     *  In/Out Parms - None.                                                                                           
     *  Out    Parms - None.                                                                                           
     *  Return       - Procedure Pointer                                                                               
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     p DYNL_GetPointerToExportedProcedure...                                                                            
     p                 b                   Export                                                                       
     d                 pi                  Like(StdPrcPtr)                                                              
     d   InActivationMark...                                                                                            
     d                                     Like(StdInt)                                                                 
     d                                     Value                                                                        
     d   InProcedureName...                                                                                             
     d                             4096    Varying                                                                      
     d                                     Value                                                                        
                                                                                                                        
     d ProcedurePointer...                                                                                              
     d                 s                   Like(StdPrcPtr)                                                              
     d MessageId...                                                                                                     
     d                 s                   Like(StdMsgId)                                                               
     d qMessageFileName...                                                                                              
     d                 s                   Like(StdQNam)                                                                
     d MessageData...                                                                                                   
     d                 s          32767    Varying                                                                      
      /Free                                                                                                             
                                                                                                                        
         Monitor;                                                                                                       
           ProcedurePointer = GetAProcedurePointer(InActivationMark:                                                    
                                                   InProcedureName );                                                   
         On-Error;                                                                                                      
           ERRH_GetLastMessage(MessageId       :                                                                        
                               qMessageFileName:                                                                        
                               MessageData     );                                                                       
           ERRH_Throw(MessageId       :                                                                                 
                      qMessageFileName:                                                                                 
                      MessageData     );                                                                                
         EndMon;                                                                                                        
                                                                                                                        
         If ProcedurePointer <> *Null;                                                                                  
            Return ProcedurePointer;                                                                                    
         EndIf;                                                                                                         
                                                                                                                        
         // If result null, try uppercasing. If you do not use ExtProc on your                                          
         // export prototype, RPGILE will upper case everything.                                                        
                                                                                                                        
         Monitor;                                                                                                       
           ProcedurePointer =                                                                                           
               GetAProcedurePointer(InActivationMark   :                                                                
                                    LowerToUpperCase(InProcedureName));                                                 
         On-Error;                                                                                                      
           ERRH_GetLastMessage(MessageId       :                                                                        
                               qMessageFileName:                                                                        
                               MessageData     );                                                                       
           ERRH_Throw(MessageId       :                                                                                 
                      qMessageFileName:                                                                                 
                      MessageData     );                                                                                
         EndMon;                                                                                                        
                                                                                                                        
         If ProcedurePointer <> *Null;                                                                                  
            Return ProcedurePointer;                                                                                    
         EndIf;                                                                                                         
                                                                                                                        
         // If still null, throw error.                                                                                 
                                                                                                                        
         If ProcedurePointer = *Null;                                                                                   
           ERRH_Throw('UXV0022'                           :                                                             
                      cXVMessageFileName                  :                                                             
                      'DYNL_GetPointerToExportedProcedure');                                                            
         EndIf;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     * DYNL_GetPointerToExportedVariable                                                                               
     *   Function is responsible for getting a pointer to an exported                                                  
     *     variable using an Activation Mark to the service program                                                    
     *     containing the exported variable.                                                                           
     *  In     Parms - Activation Mark.                                                                                
     *                 Variable Name.                                                                                  
     *  In/Out Parms - None.                                                                                           
     *  Out    Parms - None.                                                                                           
     *  Return       - Pointer To Variable.                                                                            
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     p DYNL_GetPointerToExportedVariable...                                                                             
     p                 b                   Export                                                                       
     d                 pi                  Like(StdPtr)                                                                 
     d   InActivationMark...                                                                                            
     d                                     Like(StdInt)                                                                 
     d                                     Value                                                                        
     d   InVariableName...                                                                                              
     d                             4096    Varying                                                                      
     d                                     Value                                                                        
                                                                                                                        
     d VariablePointer...                                                                                               
     d                 s                   Like(StdPtr)                                                                 
     d MessageId...                                                                                                     
     d                 s                   Like(StdMsgId)                                                               
     d qMessageFileName...                                                                                              
     d                 s                   Like(StdQNam)                                                                
     d MessageData...                                                                                                   
     d                 s          32767    Varying                                                                      
      /Free                                                                                                             
                                                                                                                        
         Monitor;                                                                                                       
           VariablePointer = GetAVariablePointer(InActivationMark:                                                      
                                                 InVariableName  );                                                     
                                                                                                                        
         On-Error;                                                                                                      
           ERRH_GetLastMessage(MessageId       :                                                                        
                               qMessageFileName:                                                                        
                               MessageData     );                                                                       
           ERRH_Throw(MessageId       :                                                                                 
                      qMessageFileName:                                                                                 
                      MessageData     );                                                                                
         EndMon;                                                                                                        
                                                                                                                        
         If VariablePointer <> *Null;                                                                                   
            Return VariablePointer;                                                                                     
         EndIf;                                                                                                         
                                                                                                                        
         // If result null, try uppercasing. If you do not use ExtVar  on your                                          
         // export prototype, RPGILE will upper case everything.                                                        
                                                                                                                        
         Monitor;                                                                                                       
           VariablePointer = GetAVariablePointer(InActivationMark         :                                             
                                           LowerToUpperCase(InVariableName));                                           
         On-Error;                                                                                                      
           ERRH_GetLastMessage(MessageId       :                                                                        
                               qMessageFileName:                                                                        
                               MessageData     );                                                                       
           ERRH_Throw(MessageId       :                                                                                 
                      qMessageFileName:                                                                                 
                      MessageData     );                                                                                
         EndMon;                                                                                                        
                                                                                                                        
         If VariablePointer <> *Null;                                                                                   
            Return VariablePointer;                                                                                     
         EndIf;                                                                                                         
                                                                                                                        
         // If still null, throw error.                                                                                 
                                                                                                                        
         If VariablePointer = *Null;                                                                                    
           ERRH_Throw('UXV0022'                          :                                                              
                      cXVMessageFileName                 :                                                              
                      'DYNL_GetPointerToExportedVariable');                                                             
         EndIf;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     * GetAProcedurePointer                                                                                            
     *   Function is responsilble for getting a pointer to a procedure.                                                
     *  In     Parms - Activation Mark.                                                                                
     *                 Procedure Name.                                                                                 
     *  In/Out Parms - None.                                                                                           
     *  Out    Parms - None.                                                                                           
     *  Return       - Procedure Pointer.                                                                              
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     p GetAProcedurePointer...                                                                                          
     p                 b                                                                                                
     d                 pi                  Like(StdPrcPtr)                                                              
     d   InActivationMark...                                                                                            
     d                                     Like(StdInt)                                                                 
     d                                     Value                                                                        
     d   InProcedureName...                                                                                             
     d                             4096    Varying                                                                      
     d                                     Value                                                                        
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_EM                                                                                       
                                                                                                                        
     d ApiGetExportedValue...                                                                                           
     d                 pr                  ExtProc('QleGetExp')                                                         
     d                                     Like(StdPrcPtr)                                                              
     d   PR_ActivationMark...                                                                                           
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d                                     Options(*Omit  :                                                             
     d                                             *NoPass)                                                             
     d   PR_ExportNumber...                                                                                             
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d                                     Options(*Omit:                                                               
     d                                             *NoPass)                                                             
     d   PR_ExportNameLength...                                                                                         
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d                                     Options(*Omit:                                                               
     d                                             *NoPass)                                                             
     d   PR_ExportName...                                                                                               
     d                                     Like(StdStr)                                                                 
     d                                     Const                                                                        
     d                                     Options(*Omit:                                                               
     d                                             *NoPass:                                                             
     d                                             *VarSize)                                                            
     d   PR_PointerToExportItem...                                                                                      
     d                                     Like(StdPrcPtr)                                                              
     d                                     Options(*Omit:                                                               
     d                                             *NoPass)                                                             
     d   PR_ExportType...                                                                                               
     d                                     Like(StdInt)                                                                 
     d                                     Options(*Omit:                                                               
     d                                             *Nopass)                                                             
     d PR_APIErr                           LikeDs(StdErrorModel)                                                        
     d                                     Options(*Nopass)                                                             
                                                                                                                        
     d ExportType...                                                                                                    
     d                 s                   Like(StdInt)                                                                 
     d ProcedurePointer...                                                                                              
     d                 s                   Like(StdPrcPtr)                                                              
     d ApiError        ds                  LikeDs(StdErrorModel)                                                        
      /Free                                                                                                             
                                                                                                                        
         ProcedurePointer = ApiGetExportedValue(InActivationMark     :                                                  
                                                0                    :                                                  
                                                %Len(InProcedureName):                                                  
                                                InProcedureName      :                                                  
                                                *OMIT                :                                                  
                                                ExportType           :                                                  
                                                ApiError             );                                                 
                                                                                                                        
         If ApiError.BytesAvailable > 0;                                                                                
            ERRH_Throw(ApiError.MessageId  :                                                                            
                       cCPFMessageFileName :                                                                            
                       ApiError.MessageData);                                                                           
         EndIf;                                                                                                         
                                                                                                                        
         Return ProcedurePointer;                                                                                       
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     * GetAVariablePointer                                                                                             
     *   Function is responsilble for getting a pointer to a variable.                                                 
     *  In     Parms - Activation Mark.                                                                                
     *                 Variable Name.                                                                                  
     *  In/Out Parms - None.                                                                                           
     *  Out    Parms - None.                                                                                           
     *  Return       - Pointer.                                                                                        
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     p GetAVariablePointer...                                                                                           
     p                 b                                                                                                
     d                 pi                  Like(StdPtr)                                                                 
     d   InActivationMark...                                                                                            
     d                                     Like(StdInt)                                                                 
     d                                     Value                                                                        
     d   InVariableName...                                                                                              
     d                             4096    Varying                                                                      
     d                                     Value                                                                        
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_EM                                                                                       
                                                                                                                        
     d ApiGetExportedValue...                                                                                           
     d                 pr                  ExtProc('QleGetExp')                                                         
     d                                     Like(StdPtr)                                                                 
     d   PR_ActivationMark...                                                                                           
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d                                     Options(*Omit  :                                                             
     d                                             *NoPass)                                                             
     d   PR_ExportNumber...                                                                                             
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d                                     Options(*Omit:                                                               
     d                                             *NoPass)                                                             
     d   PR_ExportNameLength...                                                                                         
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d                                     Options(*Omit:                                                               
     d                                             *NoPass)                                                             
     d   PR_ExportName...                                                                                               
     d                                     Like(StdStr)                                                                 
     d                                     Const                                                                        
     d                                     Options(*Omit:                                                               
     d                                             *NoPass:                                                             
     d                                             *VarSize)                                                            
     d   PR_PointerToExportItem...                                                                                      
     d                                     Like(StdPrcPtr)                                                              
     d                                     Options(*Omit:                                                               
     d                                             *NoPass)                                                             
     d   PR_ExportType...                                                                                               
     d                                     Like(StdInt)                                                                 
     d                                     Options(*Omit:                                                               
     d                                             *Nopass)                                                             
     d PR_APIErr                           LikeDs(StdErrorModel)                                                        
     d                                     Options(*Nopass)                                                             
                                                                                                                        
     d ExportType...                                                                                                    
     d                 s                   Like(StdInt)                                                                 
     d VariablePointer...                                                                                               
     d                 s                   Like(StdPtr)                                                                 
     d ApiError        ds                  LikeDs(StdErrorModel)                                                        
      /Free                                                                                                             
                                                                                                                        
         VariablePointer = ApiGetExportedValue(InActivationMark     :                                                   
                                               0                    :                                                   
                                               %Len(InVariableName) :                                                   
                                               InVariableName       :                                                   
                                               *OMIT                :                                                   
                                               ExportType           :                                                   
                                               ApiError             );                                                  
                                                                                                                        
         If ApiError.BytesAvailable > 0;                                                                                
            ERRH_Throw(ApiError.MessageId  :                                                                            
                       cCPFMessageFileName :                                                                            
                       ApiError.MessageData);                                                                           
         EndIf;                                                                                                         
                                                                                                                        
         Return VariablePointer;                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     * LowerToUpperCase                                                                                                
     *   Function converts string from lower to upper case.                                                            
     *  In     Parms - String to Upper Case.                                                                           
     *  In/Out Parms - None.                                                                                           
     *  Out    Parms - None.                                                                                           
     *  Return       - Upper Cased String.                                                                             
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     p LowerToUpperCase...                                                                                              
     p                 b                                                                                                
     d                 pi         32767    Varying                                                                      
     d   InString...                                                                                                    
     d                            32767    Varying                                                                      
     d                                     Value                                                                        
                                                                                                                        
     d cUpper...                                                                                                        
     d                 c                   'ABCDEFGHIJKLMNOPQRSTUVWXYZ'                                                 
     d cLower...                                                                                                        
     d                 c                   'abcdefghijklmnopqrstuvwxyz'                                                 
      /Free                                                                                                             
                                                                                                                        
         Return %Xlate(cLower:cUpper:InString);                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
