     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                                                                          
     *_> DLTMOD MODULE(@5/@4)                                                                                          
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                                                           
     *_>   DBGVIEW(@9) OPTIMIZE(@8)                                                                                    
     * ---------------------------------------------------------------                                                 
     * Module.....: XVERRH_M01       Project.....:                                                                     
     * Author.....: A. Campin        Date written: 02/18/2005                                                          
     * Purpose....: Error Handling Functions. This module contains                                                     
     *                a function to throw errors back to the caller.                                                   
     * ---------------------------------------------------------------                                                 
     * Called by..: Any program requiring service.                                                                     
     * ---------------------------------------------------------------                                                 
     * Revision history:                                                                                               
     *  Project # Pgmr        Date   Desc                                                                              
     *                                                                                                                 
     * End Revision History                                                                                            
     * ---------------------------------------------------------------                                                 
     h nomain                                                                                                           
                                                                                                                        
      /copy *libl/qsrcf,cb_StdType                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,cb_Std_Con                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,XVERRH_PR                                                                                       
                                                                                                                        
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     * ERRH_Throw                                                                                                      
     *   This procedure throws a message back to previous caller where it                                              
     *    must be handling or error will be generated.                                                                 
     *       In     Parms - Message Id of Error.                                                                       
     *                      Qualified Message File Name.                                                               
     *                      Message Data.                                                                              
     *       In/Out Parms - None.                                                                                      
     *       Out    Parms - None.                                                                                      
     *     Return         - None.                                                                                      
     *= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =                                            
     p ERRH_Throw...                                                                                                    
     p                 b                   Export                                                                       
     d                 pi                                                                                               
     d   InMessageId...                                                                                                 
     d                                     Like(StdMsgId)                                                               
     d                                     Value                                                                        
     d   InQualifiedMessageFileName...                                                                                  
     d                                     Like(StdQNam)                                                                
     d                                     Value                                                                        
     d   InMessageData...                                                                                               
     d                            32767    Varying                                                                      
     d                                     Value                                                                        
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_EM                                                                                       
                                                                                                                        
     d SendProgramMessage...                                                                                            
     d                 pr                  ExtPgm('QMHSNDPM')                                                           
     d  PR_MessageId...                                                                                                 
     d                                     Like(StdMsgId)                                                               
     d                                     Const                                                                        
     d  PR_QualifiedMessageFile...                                                                                      
     d                                     Like(StdQNam)                                                                
     d                                     Const                                                                        
     d  PR_MessageData...                                                                                               
     d                            32767    Options(*VarSize)                                                            
     d                                     Const                                                                        
     d  PR_MessageDataLength...                                                                                         
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d  PR_MessageType...                                                                                               
     d                                     Like(StdNam)                                                                 
     d                                     Const                                                                        
     d  PR_ToCallStackEntry...                                                                                          
     d                            32767    Options(*VarSize)                                                            
     d                                     Const                                                                        
     d  PR_ToCallStackEntryCounter...                                                                                   
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d  PR_MessageKey...                                                                                                
     d                                     Like(StdMsgKey)                                                              
     d  PR_ErrorReturn...                                                                                               
     d                                     LikeDs(StdErrorModel)                                                        
                                                                                                                        
     d MessageKey...                                                                                                    
     d                 s                   Like(StdMsgKey)                                                              
     d ErrorReturn...                                                                                                   
     d                 ds                  LikeDs(StdErrorModel)                                                        
     d ConditionToken...                                                                                                
     d                 s                   Like(StdCndTok)                                                              
                                                                                                                        
     d MsgUXV0021...                                                                                                    
     d                 ds                  Qualified                                                                    
     d   MessageId...                                                                                                   
     d                                     Like(StdMsgId)                                                               
     d   MessageData...                                                                                                 
     d                             1024    Varying                                                                      
      /Free                                                                                                             
                                                                                                                        
      /Define ILE_SignalError                                                                                           
      /copy *libl/qsrcf,XVERRH_PR                                                                                       
      /Undefine ILE_SignalError                                                                                         
                                                                                                                        
         // Store message.                                                                                              
         ERRH_AddMessage(InMessageId               :                                                                    
                         InQualifiedMessageFileName:                                                                    
                         InMessageData             );                                                                   
                                                                                                                        
         SendProgramMessage(InMessageId               :                                                                 
                            InQualifiedMessageFileName:                                                                 
                            InMessageData             :                                                                 
                            %Len(InMessageData)       :                                                                 
                            '*ESCAPE'                 :                                                                 
                            '*'                       :                                                                 
                            1                         :                                                                 
                            MessageKey                :                                                                 
                            ErrorReturn               );                                                                
                                                                                                                        
         // If error occurs, send a notification message.                                                               
         If ErrorReturn.BytesAvailable > 0;                                                                             
            MsgUXV0021.MessageId   = ErrorReturn.MessageId;                                                             
            MsgUXV0021.MessageData = %Trim(ErrorReturn.MessageData);                                                    
            ERRH_AddMessage('UXV0021'         :                                                                         
                            cXVMessageFileName:                                                                         
                            MsgUXV0021        );                                                                        
            ConditionToken = ERRH_BuildConditionToken('CPF9899'         :                                               
                                                      99                :                                               
                                                      cConditionTypeUser);                                              
            ILE_SignalError(ConditionToken);                                                                            
         EndIf;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
