     *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                                                                          
     *_> DLTMOD MODULE(@5/@4)                                                                                          
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                                                           
     *_>   DBGVIEW(@9) OPTIMIZE(@8)                                                                                    
     * ---------------------------------------------------------------                                                 
     * Module.: XVMSGF_M01           Project.....:                                                                     
     * Author.: A. Campin            Date written: 04/03/2005                                                          
     * Purpose: Message Functions. Clear and Send Messages of various                                                  
     *            Types.                                                                                               
     * ---------------------------------------------------------------                                                 
     * Called by: Any ILE module requiring service.                                                                    
     * ---------------------------------------------------------------                                                 
     * Revision history:                                                                                               
     *  Project # Pgmr        Date   Desc                                                                              
     *                                                                                                                 
     * End Revision History                                                                                            
     * ---------------------------------------------------------------                                                 
      /EJECT                                                                                                            
     h nomain                                                                                                           
                                                                                                                        
      /copy *libl/qsrcf,cb_Std_Con                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,cb_StdType                                                                                      
                                                                                                                        
      /copy *libl/qsrcf,XVERRH_PR                                                                                       
                                                                                                                        
      /copy *libl/qsrcf,XVMSGF_PR                                                                                       
                                                                                                                        
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * MSGF_ClearProgramMessageQueue                                                                                   
     *   This function is responsible for clearing the program message                                                 
     *     queue for the current screen.                                                                               
     *      Input      - Procedure Name to send message to.                                                            
     *                   Module Name to send message to.                                                               
     *                   Program name to send message to.                                                              
     *      Output     - None                                                                                          
     *      Returns    - None                                                                                          
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p MSGF_ClearProgramMessageQueue...                                                                                 
     p                 b                   Export                                                                       
     d                 pi                                                                                               
     d   InProcedureName...                                                                                             
     d                             4096    Varying                                                                      
     d                                     Value                                                                        
     d   InModuleName...                                                                                                
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d   InProgramName...                                                                                               
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
                                                                                                                        
     *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -    -*                                          
     * Prototype for remove message function.                                                                          
     d RemoveProgramMessageFromQueue...                                                                                 
     d                 pr                  ExtPgm('QMHRMVPM')                                                           
     d   PR_InProcedure...                                                                                              
     d                             4096    Options(*VarSize)                                                            
     d                                     Const                                                                        
     d   PR_MessageStackLocation...                                                                                     
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d   PR_MessageKey...                                                                                               
     d                                     Like(StdMsgKey)                                                              
     d                                     Const                                                                        
     d   PR_RemoveWhat...                                                                                               
     d                                     Like(StdNam)                                                                 
     d                                     Const                                                                        
     d   PR_ApiError...                                                                                                 
     d                                     LikeDs(StdErrorModel)                                                        
     d                                     Const                                                                        
     d   PR_EntryLength...                                                                                              
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d   PR_ModuleProgram...                                                                                            
     d                                     Like(StdQNam)                                                                
     d                                     Const                                                                        
     d   PR_RemoveException...                                                                                          
     d                                     Like(StdNam)                                                                 
     d                                     Const                                                                        
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_EM                                                                                       
                                                                                                                        
     d MessageStackLocation...                                                                                          
     d                 s                   Like(StdInt)                                                                 
     d                                     Inz(0)                                                                       
     d MessageKey...                                                                                                    
     d                 s                   Like(StdMsgKey)                                                              
     d                                     Inz(*Blanks)                                                                 
     d RemoveWhat      s                   Like(StdNam)                                                                 
     d                                     Inz('*ALL')                                                                  
     d ProcedureNameLength...                                                                                           
     d                 s                   like(StdInt)                                                                 
     d ModulePlusProgramName...                                                                                         
     d                 s                   Like(StdQNam)                                                                
     d RemoveException...                                                                                               
     d                 s                   Like(StdNam)                                                                 
     d                                     Inz('*NO')                                                                   
     d ApiError...                                                                                                      
     d                 ds                   LikeDs(StdErrorModel)                                                       
      /Free                                                                                                             
                                                                                                                        
         ProcedureNameLength   = %Len(InProcedureName);                                                                 
         ModulePlusProgramName = InModuleName + InProgramName;                                                          
         RemoveProgramMessageFromQueue(InProcedureName      :                                                           
                                       MessageStackLocation :                                                           
                                       MessageKey           :                                                           
                                       RemoveWhat           :                                                           
                                       ApiError             :                                                           
                                       ProcedureNameLength  :                                                           
                                       ModulePlusProgramName:                                                           
                                       RemoveException      );                                                          
         If ApiError.BytesAvailable <> 0;                                                                               
           ERRH_Throw(ApiError.MessageId  :                                                                             
                      cCPFMessageFileName :                                                                             
                      ApiError.MessageData);                                                                            
         EndIf;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * MSGF_SendProgramMessage                                                                                         
     *    This function is responsible for sending a message to a program                                              
     *      message queue.                                                                                             
     *   Input      - Procedure Name to send message to.                                                               
     *                Module Name to send message to.                                                                  
     *                Program name to send message to.                                                                 
     *   In/Out     - None.                                                                                            
     *   Output     - None                                                                                             
     *   Returns    - None .                                                                                           
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p MSGF_SendProgramMessage...                                                                                       
     p                 b                   Export                                                                       
     d                 pi                                                                                               
     d   InMessageId...                                                                                                 
     d                                     Like(StdMsgId)                                                               
     d                                     Value                                                                        
     d   InQualifedMessageFileName...                                                                                   
     d                                     Like(StdQNam)                                                                
     d                                     Value                                                                        
     d   InMessageData...                                                                                               
     d                             4096    Varying                                                                      
     d                                     Value                                                                        
     d   InProcedureName...                                                                                             
     d                             4096    Varying                                                                      
     d                                     Value                                                                        
     d   InModuleName...                                                                                                
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d   InProgramName...                                                                                               
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
                                                                                                                        
     *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -    -*                                          
     * Prototype for Send Program Message Function.                                                                    
     d SendProgramMessage...                                                                                            
     d                 pr                  ExtPgm('QMHSNDPM')                                                           
     d   PR_InMessageId...                                                                                              
     d                                     Like(StdMsgId)                                                               
     d                                     Const                                                                        
     d   PR_MessageFileName...                                                                                          
     d                                     Like(StdQNam)                                                                
     d                                     Const                                                                        
     d   PR_MessageData...                                                                                              
     d                             4096    Options(*VarSize)                                                            
     d                                     Const                                                                        
     d   PR_MessageDataLength...                                                                                        
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d   PR_MessageType...                                                                                              
     d                                     Like(StdNam)                                                                 
     d                                     Const                                                                        
     d   PR_ProcedureName...                                                                                            
     d                             4096    Options(*VarSize)                                                            
     d                                     Const                                                                        
     d   PR_MessageStackLocation...                                                                                     
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d   PR_MessageKey...                                                                                               
     d                                     Like(StdMsgKey)                                                              
     d                                     Const                                                                        
     d   PR_Api_Error...                                                                                                
     d                                     LikeDs(StdErrorModel)                                                        
     d                                     Const                                                                        
     d   PR_EntryLength...                                                                                              
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d   PR_ModulePlusProgramName...                                                                                    
     d                                     Like(StdQNam)                                                                
     d                                     Const                                                                        
     d   PR_ScreenWait...                                                                                               
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_EM                                                                                       
                                                                                                                        
     d MessageDataLength...                                                                                             
     d                 s                   Like(StdInt)                                                                 
     d MessageType...                                                                                                   
     d                 s                   Like(StdNam)                                                                 
     d                                     Inz('*INFO')                                                                 
     d MessageStackLocation...                                                                                          
     d                 s                   Like(StdInt)                                                                 
     d                                     Inz(0)                                                                       
     d MessageKey...                                                                                                    
     d                 s                   Like(StdMsgKey)                                                              
     d                                     Inz(*Blanks)                                                                 
     d ProcedureNameLength...                                                                                           
     d                 s                   Like(StdInt)                                                                 
     d ModulePlusProgramName...                                                                                         
     d                 s                   Like(StdQNam)                                                                
     d ScreenWait...                                                                                                    
     d                 s                   Like(StdInt)                                                                 
     d                                     Inz(0)                                                                       
     d ApiError...                                                                                                      
     d                 ds                  LikeDs(StdErrorModel)                                                        
      /Free                                                                                                             
                                                                                                                        
         MessageDataLength = %Len(InMessageData);                                                                       
         ProcedureNameLength = %Len(InProcedureName);                                                                   
         ModulePlusProgramName = InModuleName + InProgramName;                                                          
                                                                                                                        
         SendProgramMessage(InMessageId          :                                                                      
                            InQualifedMessageFileName    :                                                              
                            InMessageData        :                                                                      
                            MessageDataLength    :                                                                      
                            MessageType          :                                                                      
                            InProcedureName      :                                                                      
                            MessageStackLocation :                                                                      
                            MessageKey           :                                                                      
                            ApiError             :                                                                      
                            ProcedureNameLength  :                                                                      
                            ModulePlusProgramName:                                                                      
                            ScreenWait           );                                                                     
         If ApiError.BytesAvailable <> 0;                                                                               
           ERRH_Throw(ApiError.MessageId  :                                                                             
                      cCPFMessageFileName :                                                                             
                      ApiError.MessageData);                                                                            
         EndIf;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * MSGF_SendBreakMessage.                                                                                          
     *   This function is responsible for sending a break message to a                                                 
     *     given set of message queues.                                                                                
     *   Input      - User or Workstation Name to Send to.                                                             
     *                  Can, also, be special values *ALL, *ALLACT,                                                    
     *                  *SYSOPR.                                                                                       
     *                Message Queue Type(*USR=User Profile, *DSP=Worksta)                                              
     *                Message String to send.                                                                          
     *   In/Out     - None.                                                                                            
     *   Output     - None.                                                                                            
     *   Returns    - None.                                                                                            
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p MSGF_SendBreakMessage...                                                                                         
     p                 b                   Export                                                                       
     d                 pi                                                                                               
     d  InMessageQueueName...                                                                                           
     d                                     Like(StdNam)                                                                 
     d                                     Value                                                                        
     d  InMessageQueueType...                                                                                           
     d                                4    Value                                                                        
     d  InMessageText...                                                                                                
     d                            32767    Varying                                                                      
     d                                     Value                                                                        
                                                                                                                        
     *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -    -*                                          
     * Prototype for Send Message(Operational Assistant) Function.                                                     
     d SendBreakMessage...                                                                                              
     d                 pr                  ExtPgm('QEZSNDMG')                                                           
     d    PR_MessageType...                                                                                             
     d                                     Like(StdNam)                                                                 
     d                                     Const                                                                        
     d    PR_DeliverMode...                                                                                             
     d                                     Like(StdNam)                                                                 
     d                                     Const                                                                        
     d    PR_InMessageText...                                                                                           
     d                            32767    Options(*VarSize)                                                            
     d                                     Const                                                                        
     d    PR_MessageTextLength...                                                                                       
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d    PR_MessageQueueName...                                                                                        
     d                                     Like(StdNam)                                                                 
     d                                     Const                                                                        
     d    PR_CountUserQueue...                                                                                          
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d    PR_MessageSentIndicator...                                                                                    
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d    PR_FunctionRequired...                                                                                        
     d                                     Like(StdInt)                                                                 
     d                                     Const                                                                        
     d    PR_ApiError...                                                                                                
     d                                     LikeDs(StdErrorModel)                                                        
     d                                     Const                                                                        
     d    PR_ShowSendDisplay...                                                                                         
     d                                     Like(StdChr)                                                                 
     d                                     Const                                                                        
     d    PR_ReplyQueueName...                                                                                          
     d                                     Like(StdQNam)                                                                
     d                                     Const                                                                        
     d    PR_MessageQueueType...                                                                                        
     d                                4    Const                                                                        
                                                                                                                        
      /copy *libl/qsrcf,CB_STD_EM                                                                                       
                                                                                                                        
     d MessageType...                                                                                                   
     d                 s                   Like(StdNam)                                                                 
     d                                     Inz('*INFO')                                                                 
     d DeliveryMode...                                                                                                  
     d                 s                   Like(StdNam)                                                                 
     d                                     Inz('*BREAK')                                                                
     d MessageTextLength...                                                                                             
     d                 s                   Like(StdInt)                                                                 
     d CountUserQueues...                                                                                               
     d                 s                   Like(StdInt)                                                                 
     d                                     Inz(1)                                                                       
     d MessageSendIndicator...                                                                                          
     d                 s                   Like(StdInt)                                                                 
     d FunctionRequested...                                                                                             
     d                 s                   Like(StdInt)                                                                 
     d ShowSendDisplay...                                                                                               
     d                 s                   Like(StdChr)                                                                 
     d                                     Inz(cNo)                                                                     
     d ReplyMessageQueueName...                                                                                         
     d                 s                   Like(StdQNam)                                                                
     d                                     Inz(*Blanks)                                                                 
     d ApiError...                                                                                                      
     d                 ds                  LikeDs(StdErrorModel)                                                        
                                                                                                                        
     d UXV0025Data...                                                                                                   
     d                 ds                  Qualified                                                                    
     d   ReasonCode...                                                                                                  
     d                                3p 0                                                                              
     d   ValuePassed...                                                                                                 
     d                                4                                                                                 
      /Free                                                                                                             
                                                                                                                        
         If InMessageQueueType <> cDisplayUserQueues and                                                                
            InMessageQueueType <> cDisplayWorkstationQueues;                                                            
            UXV0025Data.ReasonCode = 1;                                                                                 
            UXV0025Data.ValuePassed = InMessageQueueType;                                                               
            ERRH_Throw('UXV0025'         :                                                                              
                       cXVMessageFileName:                                                                              
                       UXV0025Data       );                                                                             
         EndIf;                                                                                                         
                                                                                                                        
         MessageTextLength = %Len(InMessageText);                                                                       
         SendBreakMessage(MessageType          :                                                                        
                          DeliveryMode         :                                                                        
                          InMessageText        :                                                                        
                          MessageTextLength    :                                                                        
                          InMessageQueueName   :                                                                        
                          CountUserQueues      :                                                                        
                          MessageSendIndicator :                                                                        
                          FunctionRequested    :                                                                        
                          ApiError             :                                                                        
                          ShowSendDisplay      :                                                                        
                          ReplyMessageQueueName:                                                                        
                          InMessageQueueType   );                                                                       
         If ApiError.BytesAvailable <> 0;                                                                               
           ERRH_Throw(ApiError.MessageId  :                                                                             
                      cCPFMessageFileName :                                                                             
                      ApiError.MessageData);                                                                            
         EndIf;                                                                                                         
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     * MSGF_ClearErrorIndicators                                                                                       
     *   This function is responsible for clearing error indicators.                                                   
     *     As a standard, indicators 50 to 79 are used for error                                                       
     *     indicators. Put here for lack of better place to put.                                                       
     *      Input      - Indicator Array.                                                                              
     *                   Start Error Indicators.                                                                       
     *                   End Error Indicators.                                                                         
     *      Output     - None                                                                                          
     *      Returns    - None                                                                                          
     * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -                                             
     p MSGF_ClearErrorIndicators...                                                                                     
     p                 b                   Export                                                                       
     d                 pi                                                                                               
     d   InIndicatorArray...                                                                                            
     d                                     Like(StdChr)                                                                 
     d                                     Dim(99)                                                                      
     d   InStartErrorIndicators...                                                                                      
     d                                     Like(StdIntSml)                                                              
     d                                     Value                                                                        
     d   InEndErrorIndicators...                                                                                        
     d                                     Like(StdIntSml)                                                              
     d                                     Value                                                                        
                                                                                                                        
     d x...                                                                                                             
     d                 s                   Like(StdIntSml)                                                              
      /Free                                                                                                             
                                                                                                                        
         For x = InStartErrorIndicators to InEndErrorIndicators;                                                        
           InIndicatorArray(x) = *Off;                                                                                  
         EndFor;                                                                                                        
                                                                                                                        
      /End-Free                                                                                                         
     p                 e                                                                                                
